<?php
/**
* Forum Tab Class for handling the CB tab api
* @package Community Builder
* @author JoomlaJoe and Beat
*/

// Changed by Benjamin to allow for uddeIM 0.5 support 
// version 0.5a, as of 2005/12/30

class getcbpmsTab extends cbPMSHandler {
	/**
	* Constructor
	*/
	function getcbpmsTab() {
		$this->cbPMSHandler();
	}
	function _setStatusMenuSBstats($sbConfig, $user, &$params, $sbUserDetails) {
/* already done in the core cb.menu plugin:
		global $my;
		IF($my->id!=$user->id && $my->id > 0) {
			$pmsurl=...
			$mi = array(); $mi["_UE_MENU_MESSAGES"]["_UE_PM_USER"]=null;
			$this->menuBar->addObjectItem($mi, _UE_PM_USER,sefRelToAbs($pmsurl), "",
			"","", _UE_MENU_PM_USER_DESC,"");
		}
*/
/* example for a status display:
		if ($sbConfig['postStats'] && ($params->get('statPosts', '1') == 1)) {
			$mi = array(); $mi["_UE_MENU_STATUS"][$params->get('statPostsText', "_UE_FORUM_TOTALPOSTS")]["_UE_FORUM_TOTALPOSTS"]=null;
			$_PLUGINS->addMenu( array(	"position"	=> "menuList" ,
								"arrayPos"	=> $mi ,
								"caption"	=> (($sbUserDetails !== false) ? $sbUserDetails->posts : "0") ,
								"url"		=> "" ,
								"target"	=> "" ,
								"img"		=> null ,
								"alt"		=> null ,
								"tooltip"	=> "") );
		}
*/
	}
	function _checkPMSinstalled($pmsType) {
		if (!(	($pmsType==1 && file_exists('components/com_pms/pms.php'))
			||	($pmsType==2 && file_exists('components/com_mypms/mypms.php'))
			||	(($pmsType==3 || $pmsType==4) && file_exists('components/com_uddeim/uddeim.php')))) {
			$this->_setErrorMSG(_UE_PMS_NOTINSTALLED);
			return false;
		}
		return true;
	}
	function _sendPMSProMSG($to,$from,$sub,$msg) {
		global $database;
		$sql="INSERT INTO #__mypms (username,whofrom,time,readstate,subject,message,owner,sent_id) VALUES('"
			.$to."','".$from."',NOW(),0,'".$sub."','".$msg."','".$to."',0);";
		$database->SetQuery($sql);
		if (!$database->query()) {
			die("SQL error" . $database->stderr(true));
		}
	
	}
	function _sendPMSOSMSG($to,$from,$sub,$msg) {
		global $database;
		$sql="INSERT INTO #__pms (username,whofrom,date,time,readstate,subject,message) VALUES('"
			.$to."','".$from."',CURDATE(),CURTIME(),0,'".$sub."','".$msg."');";
		$database->SetQuery($sql);
		if (!$database->query()) {
			die("SQL error" . $database->stderr(true));
		}
	}
	function _sendPMSuddesysMSG($udde_toid,$udde_fromid,$to,$from,$sub,$msg) {
		global $database; 
		
		// get the preset default username for system messages from the udde config
		
		// define the variable
		$udde_sysm = "System";
		$config_realnames="0";
		
		// look if it is defined in udde config
		if(file_exists("administrator/components/com_uddeim/uddeim_config.php")) {
			include("administrator/components/com_uddeim/uddeim_config.php");
		} 

		// if yes, assign it
		if($config_sysm_username) {
			$udde_sysm = $config_sysm_username;		
		}

		// format the message
		if($sub) {
			$udde_msg = "[b]".$sub."[/b]\n\n".$msg;
		} else {
			$udde_msg = $msg;
		}
		
		// now change the <strong> or <b> tags to BB Code
		$udde_msg = str_replace("<strong>","[b]",$udde_msg);
		$udde_msg = str_replace("<b>","[b]",$udde_msg);
		$udde_msg = str_replace("</strong>","[/b]",$udde_msg);
		$udde_msg = str_replace("</b>","[/b]",$udde_msg);
		
		// now change the links to BB code links
		$udde_msg = str_replace("<a href=\"", "[url=", $udde_msg);
		$udde_msg = str_replace("<a href=\\\"", "[url=", $udde_msg);		
		$udde_msg = str_replace("\">", "]", $udde_msg);
		$udde_msg = str_replace("\\\">", "]", $udde_msg);		
		$udde_msg = str_replace("</a>", "[/url]", $udde_msg);
		$udde_msg = str_replace("<br/>", "\n", $udde_msg);
		$udde_msg = str_replace("<br />", "\n", $udde_msg);
		$udde_msg = str_replace("<br>", "\n", $udde_msg);
		$udde_msg = str_replace("&amp;", "&", $udde_msg);
		
		// workaround
		// commands above made the closing bracket of the div to a ]
		// we change it back to a > here so that the next command can strip the div entirely
		$udde_msg = str_replace("cbNotice\\\"]", "cbNotice\\\">", $udde_msg);
		$udde_msg = str_replace("cbNotice]", "cbNotice\">", $udde_msg);
		$udde_msg = str_replace("cbNotice\]", "cbNotice\">", $udde_msg);
		
		// now strip the remaining html tags
		$udde_msg = strip_tags($udde_msg);
		
		// get current time but recognize mosConfig Offset
		global $mosConfig_offset;
		$rightnow=time()+($mosConfig_offset*3600);
		$udde_time=$rightnow;


		
		// set the udde systemmessage username to the virtual sender
		$udde_sysm=$from;
		
		// try to find the realnames settings of udde
		// if(file_exists('administrator/components/com_uddeim/uddeim_config.php')) {
			// include('administrator/components/com_uddeim/uddeim_config.php');
			if($config_realnames) {
				$sql="SELECT name FROM #__users WHERE id=".$udde_fromid;
				$database->setQuery($sql);
				$quereply=$database->loadResult();
				if($quereply) {
					$udde_sysm=$quereply;
				}
			}
		// }
		
		// escaping not necessary, already escaped before this internal function gets called
		// now insert the message as system message 
		// REPLY IS NOT DISABLED AS THE SYSTEMMESSAGE USERNAME WILL CONTAIN A VALID USERNAME
		if($udde_fromid && $udde_toid) {
			$sql="INSERT INTO #__uddeim (fromid, toid, message, datum, systemmessage, disablereply) VALUES (".$udde_fromid.", ".$udde_toid.", '".$udde_msg."', ".$udde_time.", '".$udde_sysm."', 0)";
			$database->SetQuery($sql);
			if (!$database->query()) {
				die("SQL error" . $database->stderr(true));
			}
		}
	}
	function _sendPMSuddeimMSG($udde_toid,$udde_fromid,$to,$from,$sub,$msg) {
		global $database; 
		
		// format the message
		if($sub) { // is actually impossible
			$udde_msg = "[b]".$sub."[/b]\n\n".$msg;
		} else {
			$udde_msg = $msg;
		}
		
		// strip any bb code that might be present, but only in 0.4
		$params = $this->params;
		$pmsType = $params->get('pmsType', '1');
		if($pmsType==3) {
			require_once ('components/com_uddeim/bbparser.php');
			$udde_msg=bbcode_strip($udde_msg);
		}
		
		// now strip the remaining html tags
		$udde_msg = strip_tags($udde_msg);
		
		// escape dangerous stuff
		// not necessary, already escaped before this internal function gets called
		
		// get current time but recognize mosConfig Offset
		global $mosConfig_offset;
		$rightnow=time()+($mosConfig_offset*3600);
		$udde_time=$rightnow;
		
		// set the udde systemmessage username to the virtual sender
		
		$udde_sysm=$from;
			
		// now insert the message  
		if($udde_fromid && $udde_toid) {
			$sql="INSERT INTO #__uddeim (fromid, toid, message, datum) VALUES (".$udde_fromid.", ".$udde_toid.", '".$udde_msg."', ".$udde_time.")";
			$database->SetQuery($sql);
			if (!$database->query()) {
				die("SQL error" . $database->stderr(true));
			}
		}
	}
	
	
	/**
	* Sends a PMS message
	* @param int userId of receiver (ESCAPED)
	* @param int userId of sender (ESCAPED)
	* @param string subject of PMS message (ESCAPED Subject) 
	* @param string body of PMS message (html, ESCAPED Body)
	* @param boolean false: real user-to-user message = default; true: system-Generated by an action from user $fromid (if non-null)
	* @param boolean false: subject and message body UNESCAPED = default; true: ESCAPED
	* @return boolean : true for OK, or false if ErrorMSG generated. Special error: _UE_PMS_TYPE_UNSUPPORTED : if anonym fromid>=0 sysgenerated unsupported
	*/
	function sendUserPMS($toid, $fromid, $subject, $message, $systemGenerated=false, $escaped=false) {
		global $database;

		$params = $this->params;
		$pmsType = $params->get('pmsType', '1');

		if (!$this->_checkPMSinstalled($pmsType)) {
			return false;
		}

		if ($systemGenerated && ($fromid == 0)) {
			if (in_array($pmsType,array(1,2))) {
				$this->_setErrorMSG(_UE_PMS_TYPE_UNSUPPORTED);		// PMS OS and MyPMS Pro do not handle systemGenerated from nobody)
				return false;
			}
		}

		if ($fromid != 0) {
			$rowFrom = new mosUser( $database );
			$rowFrom->load( $fromid );
			$from = $rowFrom->username;
		} else {
			$from = null;
		}
		
		$rowTo = new mosUser( $database );
		$rowTo->load( $toid );	
		$to=$rowTo->username;
		
		if (!$escaped) {
			$subject = $database->getEscaped($subject);
			$message = $database->getEscaped($message);
		}
		SWITCH($pmsType) {
			case 1:
				$this->_sendPMSOSMSG($to,$from,$subject,$message);
				return true;
				break;
			case 2:
				$this->_sendPMSProMSG($to,$from,$subject,$message);
				return true;
				break;
			case 3:
			case 4:
				if($systemGenerated || $fromid==0) {
					$this->_sendPMSuddesysMSG($toid,$fromid,$to,$from,$subject,$message);
				} else {
					$this->_sendPMSuddeimMSG($toid,$fromid,$to,$from,$subject,$message);				
				}
				return true;
				break;
			default:
				$this->_setErrorMSG("Incorrect PMS type");
				return false;
				break;
		}
	}
	/**
	* returns all the parameters needed for a hyperlink or a menu entry to do a pms action
	* @param int userId of receiver
	* @param int userId of sender
	* @param string subject of PMS message
	* @param string body of PMS message
	* @param int kind of link: 1: link to compose new PMS message for $toid user. 2: link to inbox of $fromid user; 3: outbox, 4: trashbox,
	  5: link to edit pms options
	* @return mixed array of string {"caption" => menu-text ,"url" => NON-sefRelToAbs relative url-link, "tooltip" => description} or false and errorMSG
	*/
	function getPMSlink($toid, $fromid, $subject, $message, $kind) {
		global $database;

		$params = $this->params;
		$pmsType		= $params->get('pmsType', '1');

		if (!$this->_checkPMSinstalled($pmsType)) {
			return false;
		}
		
		SWITCH($pmsType) {
			case 1:
				$rowTo = new mosUser( $database );
				$rowTo->load( $toid );	
				$pmsurlBase="index.php?option=com_pms";
				$pmsurlSend=$pmsurlBase."&amp;page=new&amp;id=".urlencode($rowTo->username);
				$pmsurlInbox=$pmsurlBase."&amp;page=index";
				break;
			case 2:
				$rowTo = new mosUser( $database );
				$rowTo->load( $toid );	
				$pmsurlBase="index.php?option=com_mypms";
				$pmsurlSend=$pmsurlBase."&amp;task=new&amp;to=".urlencode($rowTo->username);
				$pmsurlInbox=$pmsurlBase."&amp;task=inbox";
				$pmsurlOutbox=$pmsurlBase."&amp;task=sent";
				$pmsurlTrashbox=$pmsurlBase."&amp;task=trash";
				$pmsurlOptions=$pmsurlBase."&amp;task=editprofile";
				break;
			case 3:
				$pmsurlBase="index.php?option=com_uddeim";
				$pmsurlSend=$pmsurlBase."&amp;task=new&amp;recip=".$toid;
				$pmsurlInbox=$pmsurlBase."&amp;task=inbox";
				$pmsurlOutbox=$pmsurlBase."&amp;task=outbox";
				$pmsurlTrashbox=$pmsurlBase."&amp;task=trashcan";
				break;		
			case 4:
				$pmsurlBase="index.php?option=com_uddeim";
				$pmsurlSend=$pmsurlBase."&amp;task=new&amp;recip=".$toid;
				$pmsurlInbox=$pmsurlBase."&amp;task=inbox";
				$pmsurlOutbox=$pmsurlBase."&amp;task=outbox";
				$pmsurlTrashbox=$pmsurlBase."&amp;task=trashcan";
				$pmsurlOptions=$pmsurlBase."&amp;task=settings";				
				break;							
			default:
				$this->_setErrorMSG("Incorrect PMS type");
				return false;
				break;
		}
		switch($kind) {
			case 1:
				return array("caption"	=> $params->get('pmsMenuText', _UE_PM_USER),
							 "url"		=> $pmsurlSend,
							 "tooltip"	=> $params->get('pmsMenuDesc', _UE_MENU_PM_USER_DESC));
				break;
			case 2:
				return array("caption"	=> $params->get('pmsMenuInboxText', _UE_PM_INBOX),
							 "url"		=> $pmsurlInbox,
							 "tooltip"	=> $params->get('pmsMenuInboxDesc', _UE_MENU_PM_INBOX_DESC));
				break;
			case 3:
				if ($pmsType != 1) return array("caption"	=> $params->get('pmsMenuOutboxText', _UE_PM_OUTBOX),
												"url"		=> $pmsurlOutbox,
												"tooltip"	=> $params->get('pmsMenuOutboxDesc', _UE_MENU_PM_OUTBOX_DESC));
				break;
			case 4:
				if ($pmsType != 1) return array("caption"	=> $params->get('pmsMenuTrashboxText', _UE_PM_TRASHBOX),
												"url"		=> $pmsurlTrashbox,
												"tooltip"	=> $params->get('pmsMenuTrashboxDesc', _UE_MENU_PM_TRASHBOX_DESC));
				break;
			case 5:
				if ($pmsType == 2) return array("caption"	=> $params->get('pmsMenuOptionsText', _UE_PM_OPTIONS),
												"url"		=> $pmsurlOptions,
												"tooltip"	=> $params->get('pmsMenuOptionsDesc', _UE_MENU_PM_OPTIONS_DESC));
				break;

			default:
			break;
		}
		$this->_setErrorMSG("Function not supported by this PMS type");
		return false;
	}
	/**
	* gets PMS system capabilities
	* @return mixed array of string {"subject" => boolean ,"body" => boolean} or false if ErrorMSG generated
	*/
	function getPMScapabilites() {
		$params = $this->params;
		$pmsType		= $params->get('pmsType', '1');

		if (!$this->_checkPMSinstalled($pmsType)) {
			return false;
		}
		
		SWITCH($pmsType) {
			case 1:
			case 2:
				$capacity = array( "subject" => true, "body" => true);
				break;
			case 3:
			case 4:
				$capacity = array( "subject" => false, "body" => true);
				break;
			default:
				$this->_setErrorMSG("Incorrect PMS type");
				$capacity = false;
				break;
		}
		return $capacity;
	}
	/**
	* gets PMS unread messages count
	* @param	int user id
	* @return	mixed number of messages unread by user $userid or false if ErrorMSG generated
	*/
	function getPMSunreadCount($userid) {
		global $database;

		$params = $this->params;
		$pmsType = $params->get('pmsType', '1');

		if (!$this->_checkPMSinstalled($pmsType)) {
			return false;
		}

		$user = new mosUser( $database );
		$user->load( $userid );
		
		SWITCH($pmsType) {
			case 1:
				$query_pms_count = "SELECT count(id) FROM #__pms WHERE username='$user->username' AND readstate=0";
				$database->setQuery( $query_pms_count );
				$total_pms = $database->loadResult();
				break;
			case 2:
				$query_pms_count = "SELECT count(id) FROM #__mypms WHERE username='$user->username' AND readstate=0";
				$database->setQuery( $query_pms_count );
				$total_pms = $database->loadResult();
				break;
			case 3:
			case 4:
				$sql="SELECT count(id) FROM #__uddeim WHERE toread<1 AND toid=".$userid;
				$database->setQuery($sql);
				$total_pms = $database->loadResult();	
				break;			
			default:
				$this->_setErrorMSG("Incorrect PMS type");
				$total_pms = false;
				break;
		}
		return $total_pms;
	}

	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
	*/
	function getDisplayTab($tab,$user,$ui) {
		global $my, $_POST, $_CB_OneTwoRowsStyleToggle;

		if (!$my->id) {
			return _NOT_AUTH;
		}

		$return = "";

		$params = $this->params;
		$pmsType		= $params->get('pmsType', '1');
		$showTitle		= $params->get('showTitle', "1");
		$showSubject	= $params->get('showSubject', "1");
		$width			= $params->get('width', "30");
		$height			= $params->get('height', "5");

		$capabilities = $this->getPMScapabilites();

		if (!$this->_checkPMSinstalled($pmsType) || ($capabilities === false)) {
			return false;
		}
		if ($my->id == $user->id) {
			return null;
		}

		$newsub = null;
		$newmsg = null;

		// send PMS from this tab form input:
		if (isset($_POST[$this->_getPagingParamName("sndnewmsg")]) && $_POST[$this->_getPagingParamName("sndnewmsg")] == _UE_PM_SENDMESSAGE) {
			$sender = $this->_getReqParam("sender", null);
			$recip = $this->_getReqParam("recip", null);
			if ($sender && $recip) {
				$newsub = htmlentities($this->_getReqParam("newsub", null));	//urldecode done in _getReqParam
				if($pmsType=='3' || $pmsType=='4') {
					$newmsg = $this->_getReqParam("newmsg", null);	
				} else {
					$newmsg = htmlentities($this->_getReqParam("newmsg", null));	//don't allow html input on user profile!
				}
				if ($newsub || $newmsg) {
					if (isset($_POST[$this->_getPagingParamName("protect")])
					&& $_POST[$this->_getPagingParamName("protect")] == md5("hash".$user->id.$user->password.$user->lastvisitDate.$my->password.$my->lastvisitDate) )
					{
						if ($newsub === null && $capabilities["subject"]) $newsub = _UE_PM_PROFILEMSG;
						if ($this->sendUserPMS($recip, $sender, $newsub, $newmsg, $systemGenerated=false, $escaped=true)) {
							$return .= "\n<script type='text/javascript'>alert('"._UE_PM_SENTSUCCESS."')</script>";
							$newsub = null;
							$newmsg = null;
						} else {
							$return .= "\n<script type='text/javascript'>alert('".$this->getErrorMSG()."')</script>";
						}
					} else {
						$return .= "\n<script type='text/javascript'>alert('"._UE_SESSIONTIMEOUT." "._UE_PM_NOTSENT." "._UE_TRYAGAIN."')</script>";
					}
				} else {
					$return .= "\n<script type='text/javascript'>alert('"._UE_PM_EMPTYMESSAGE." "._UE_PM_NOTSENT."')</script>";
				}
			}
		}
		// display Quick Message tab:
		$return .= "\n\t<div class=\"sectiontableentry".$_CB_OneTwoRowsStyleToggle."\" style=\"padding-bottom:5px;\">\n";
		$_CB_OneTwoRowsStyleToggle = ($_CB_OneTwoRowsStyleToggle == 1 ? 2 : 1);
		if($showTitle) $return .= "\t\t<div class=\"titleCell\" style=\"align: left; text-align:left; margin-left: 0px;\">"
							.unHtmlspecialchars(getLangDefinition($tab->title)).(($showSubject && $capabilities["subject"])?"":":")."</div>\n";
		if($tab->description != null) $return .= "\t\t<div class=\"tab_Description\" style=\"text-align:left; margin-left: 5px;\">"
							.unHtmlspecialchars(getLangDefinition($tab->description))."</div>\n";
		$base_url = $this->_getAbsURLwithParam(array());
		$return .= '<form method="post" action="'.$base_url.'">';
		$return .= '<table cellspacing="0" cellpadding="5" class="contentpane" style="border:0px;align:left;width:90%;">';
		if ($showSubject && $capabilities["subject"]) {
			$return .= '<tr><td><b>'._UE_EMAILFORMSUBJECT.'</b></td>';
			$return .= '<td><input type="text" class="inputbox" name="'.$this->_getPagingParamName("newsub")
					.'" size="'.($width-8).'" value="'.stripslashes($newsub).'" /></td></tr>';
			$return .= '<tr class="sectiontableentry1"><td colspan="2"><b>'._UE_EMAILFORMMESSAGE.'</b></td></tr>';
		}
		$return .= '<tr><td colspan="2"><textarea name="'.$this->_getPagingParamName("newmsg")
				.'" class="inputbox" rows="'.$height.'" cols="'.$width.'">'.stripslashes($newmsg).'</textarea></td></tr>';
		$return .= '<tr><td colspan="2"><input type="submit" class="button" name="'.$this->_getPagingParamName("sndnewmsg").'" value="'._UE_PM_SENDMESSAGE.'" /></td></tr>';
		$return .= '</table>';
		$return .= "<input type=\"hidden\"  name=\"".$this->_getPagingParamName("sender")."\" value=\"$my->id\" />";
		$return .= "<input type=\"hidden\"  name=\"".$this->_getPagingParamName("recip")."\" value=\"$user->id\" />";
		$return .= "<input type=\"hidden\"  name=\"".$this->_getPagingParamName("protect")."\" value=\"".md5("hash".$user->id.$user->password.$user->lastvisitDate.$my->password.$my->lastvisitDate)."\" />";
		$return .= '</form>';
		$return .= "</div>";

		return $return;
	}
}	// end class getcbpmsTab.
?>